/* qsfar.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int qsfar_c(real *rint1, real *rint2, real *a, real *b,
        R_fp f, real *ro, real *fi, real *e, real *alfa, real *beta, real *xa,
        real *e1, integer *l1, integer *l2)
{
    /* Initialized data */

    static real sys059 = 3.4e38f;
    static real con = 2e-10f;
    static real cont99 = .999999f;
    static real cone = 1e-15f;

    /* System generated locals */
    real r__1, r__2, r__3, r__4;

    /* Builtin functions */
    double sin(doublereal), cos(doublereal);

    /* Local variables */
    static real rint3, rint4, c__, d__, g, h__, i__, j, k, l, m, o, p, q, r__,
             s, t;
    static integer u, v;
    static real w;
    static integer x;
    static logical y, z__;
    static real e2, e3, j1, j2, z1, z2, ba, bb, bc;
    static integer bd;
    static real be[5], bf, bg, bh, bi[5], bj[5], bk[5], bl, bm, bn, bo, bp, 
            bq;
    static integer il;
    static real br, bs, bt, bw[7], bu, bv, bx, hm;
    static logical mi, ni;
    static real eps, tau;
    static logical nis;

    nis = *a > *b;
    if (! nis) {
        goto L1;
    }
    ba = *a;
    *a = *b;
    *b = ba;
L1:
    v = 2;
    eps = *e;
    hm = con;
    *xa = -sys059;
    y = TRUE_;
    x = 1;
    c__ = 0.f;
    d__ = 0.f;
    g = 0.f;
    i__ = 0.f;
    if ((r__1 = *beta - *alfa) < 0.f) {
        goto L2;
    } else if (r__1 == 0) {
        goto L3;
    } else {
        goto L4;
    }
L2:
    ba = *alfa;
    *alfa = *beta;
    *beta = ba;
    goto L4;
L3:
    *alfa -= hm;
    *beta += hm;
L4:
    if (*b - 100.f >= 0.f) {
        goto L5;
    } else {
        goto L7;
    }
L5:
    if (*a + 100.f <= 0.f) {
        goto L6;
    } else {
        goto L38;
    }
L6:
    y = FALSE_;
    x = -1;
    k = *b;
    *e /= 2.f;
    *b = *a;
    *a = *alfa;
    goto L38;
L7:
    x = -1;
    o = *a;
    *a = *b;
    *b = o;
    goto L38;
L8:
    ni = *a > *b;
    if (! ni) {
        goto L9;
    }
    ba = *a;
    *a = *b;
    *b = ba;
L9:
    w = *b - *a;
    if (! (w == 0.f)) {
        goto L10;
    }
    j1 = 0.f;
    j2 = 0.f;
    *e1 = 0.f;
    goto L37;
L10:
    mi = *alfa < *beta &&
             (*a <= *alfa && *alfa < *b || *a < *beta && *beta <= *b);
    if (! mi) {
        goto L12;
    }
    *alfa = (*alfa - *a) / w;
    *beta = (*beta - *a) / w;
    tau = (*beta - *alfa) / 2.f;
    if (tau - hm <= 0.f) {
        goto L11;
    } else {
        goto L12;
    }
L11:
    tau = hm;
L12:
    z2 = *e / w;
    h__ = 1.f;
    z1 = eps / w;
    p = 0.f;
    *e1 = 0.f;
    j1 = 0.f;
    j2 = 0.f;
L13:
    if (! mi) {
        goto L14;
    }
    if (! (p < *beta && p + h__ > *alfa && h__ > tau)) {
        goto L14;
    }
    h__ = tau;
    if (p >= *alfa) {
        goto L14;
    }
    h__ = *alfa - p;
    if (h__ < tau) {
        h__ = tau;
    }
L14:
    bm = h__ / 2.f;
    bl = w * bm;
    bq = bl * *ro;
    bo = h__ * .25f;
    for (bd = 1; bd <= 5; ++bd) {
        r__1 = *a + w * (p + bo * (real) (bd - 1));
        bi[bd - 1] = (real)(*f)(&r__1);
/* L15: */
    }
L16:
    if ((real) (*l1 + *l2) < 1.5f && bq <= .25f) {
        goto L17;
    }
    bn = (r__1 = bi[0] + bi[4] - (bi[1] + bi[3]) * 4.f + bi[2] * 6.f,
            abs(r__1));
    goto L19;
L17:
    bf = (*a + w * (p + bm)) * *ro + *fi;
    for (bd = 1; bd <= 5; ++bd) {
        bj[bd - 1] = bi[bd - 1] * (real)sin(bf);
        bk[bd - 1] = bi[bd - 1] * (real)cos(bf);
/* L18: */
    }
    bf = bj[0] + bj[4] - (bj[1] + bj[3]) * 4.f + bj[2] * 6.f;
    bn = bk[0] + bk[4] - (bk[1] + bk[3]) * 4.f + bk[2] * 6.f;
/* Computing MAX */
    r__1 = (real) (*l1) * abs(bf), r__2 = (real) (*l2) * abs(bn);
    bn = max(r__1,r__2);
L19:
    bn = bn * bm * .42f;
    if (abs(bn) - z1 >= 0.f) {
        goto L20;
    } else {
        goto L25;
    }
L20:
    h__ /= 2.f;
    if (h__ + 64.f - 64.f <= 0.f) {
        goto L21;
    } else {
        goto L24;
    }
L21:
    if (p <= 0.f) {
        goto L22;
    } else {
        goto L23;
    }
L22:
    if (h__ / 4.f <= 0.f) {
        goto L23;
    } else {
        goto L24;
    }
L23:
    *xa = (p + *a) * w;
    p += h__ * 2.f;
    h__ *= 2.f;
    goto L25;
L24:
    bi[4] = bi[2];
    bi[2] = bi[1];
    bm = h__ * .5f;
    bq = w * bm * *ro;
    bo = h__ * .25f;
    bp = p + bo;
    r__1 = *a + w * bp;
    bi[1] = (real)(*f)(&r__1);
    r__1 = *a + w * (bp + bm);
    bi[3] = (real)(*f)(&r__1);
    goto L16;
L25:
    *e1 += abs(bn);
    bf = (*a + w * (p + bm)) * *ro + *fi;
    bt = (real)sin(bf);
    bu = (real)cos(bf);
    bl = w * bm;
    bv = *ro * bl;
    bw[3] = (real)sin(bv);
    bw[4] = (real)cos(bv);
    if (bv - .33f <= 0.f) {
        goto L26;
    } else {
        goto L27;
    }
L26:
    bx = bv * .5f;
    bw[5] = (real)sin(bx);
    bw[6] = (real)cos(bx);
    be[0] = .2666667f;
    be[1] = bw[6] * .7111111f;
    be[2] = bw[4] * .1555556f;
    be[3] = bw[5] * .7111111f;
    be[4] = bw[3] * .1555556f;
    goto L28;
L27:
    bw[0] = 1.f / bv;
    bw[1] = bw[0] * bw[0];
    bw[2] = bw[1] * bw[1];
    be[0] = bw[1] * 4.f * (bw[0] * (bw[1] * 48.f - 19.f) * bw[3] +
            (1.f - bw[1] * 16.f) * 3.f * bw[4]);
    be[1] = bw[1] * 32.f * (bw[0] * (5.f - bw[1] * 12.f) * bw[3] -
            (1.f - bw[1] * 12.f) * bw[4]) / 3.f;
    be[2] = bw[0] * ((3.f - bw[1] * 46.f + bw[2] * 96.f) * bw[3] + bw[0] * 
            2.f * (7.f - bw[1] * 48.f) * bw[4]) / 3.f;
    be[3] = bw[1] * -16.f * ((1.f - bw[1] * 3.f) * bw[3] + bw[0] * 3.f *
            bw[4]) / 3.f;
    be[4] = bw[0] * (bw[0] * (11.f - bw[1] * 24.f) * bw[3] -
            (1.f - bw[1] * 8.f) * 3.f * bw[4]) / 3.f;
L28:
    br = be[0] * bi[2] + be[1] * (bi[1] + bi[3]) + be[2] * (bi[0] + bi[4]);
    bs = be[3] * (bi[3] - bi[1]) + be[4] * (bi[4] - bi[0]);
    j1 += (bt * br + bu * bs) * bm;
    j2 += (bu * br - bt * bs) * bm;
    p += h__;
    bh = 1.f - p;
    if (bh / 64.f + 1.f - 1.f <= 0.f) {
        goto L29;
    } else {
        goto L31;
    }
L29:
    bg = ((r__1 = (real)(*f)(b), abs(r__1)) + abs(bi[4])) * h__ / 2.f;
    if (bg - z2 <= 0.f) {
        goto L35;
    } else {
        goto L30;
    }
L30:
    *e1 += bg;
    goto L35;
L31:
    bi[0] = bi[4];
    if (bn - z1 / 32.f >= 0.f) {
        goto L33;
    } else {
        goto L32;
    }
L32:
    h__ *= 2.f;
L33:
    if (h__ - bh <= 0.f) {
        goto L13;
    } else {
        goto L34;
    }
L34:
    h__ = bh;
    goto L13;
L35:
    j1 *= w;
    j2 *= w;
    *e1 *= w;
    if (! ni) {
        goto L36;
    }
    ba = *b;
    *b = *a;
    *a = ba;
L36:
    if (! mi) {
        goto L37;
    }
    *alfa = *alfa * w + *a;
    *beta = *beta * w + *a;
L37:
    switch (u) {
        case 1:  goto L42;
        case 2:  goto L47;
    }
L38:
    il = 1;
    j = *b;
    l = *a;
    e2 = *e;
    *e = 1e3f;
L39:
    *b = l + v * x;
    if ((*b - j) * x <= 0.f) {
        goto L41;
    } else {
        goto L40;
    }
L40:
    *b = j;
L41:
    u = 1;
    goto L8;
L42:
    *rint1 = j1;
    *rint2 = j2;
/* Computing MAX */
    r__1 = abs(j1) * (real) (*l1), r__2 = abs(j2) * (real) (*l2);
    q = max(r__1,r__2);
    e3 = *e1;
L43:
    r__ = q;
L44:
    z__ = FALSE_;
    *a = *b;
    *b = l + (*b - l) * v;
    if ((*b - j) * x <= 0.f) {
        goto L46;
    } else {
        goto L45;
    }
L45:
    *b = j;
L46:
    u = 2;
    goto L8;
L47:
    *rint1 += j1;
    *rint2 += j2;
/* Computing MAX */
    r__1 = abs(j1) * (real) (*l1), r__2 = abs(j2) * (real) (*l2);
    q = max(r__1,r__2);
    e3 += *e1;
    if (q == 0.f && r__ == 0.f) {
        goto L51;
    }
L48:
    if (q - cont99 * r__ >= 0.f) {
        goto L44;
    } else {
        goto L49;
    }
L49:
    s = q / r__;
    s = q * s / (1.f - s);
    if (s - e2 >= 0.f) {
        goto L44;
    } else {
        goto L50;
    }
L50:
    if (! z__) {
        goto L58;
    }
    e3 += s;
L51:
    ++il;
/* Computing MAX */
    r__1 = abs(*rint1) * (real) (*l1), r__2 = abs(*rint2) * (real) (*l2);
    bb = max(r__1,r__2);
    bb = e2 * (bb + 1.f);
    if (e3 - bb <= 0.f) {
        goto L59;
    } else {
        goto L52;
    }
L52:
    if (il - 1 != 0) {
        goto L53;
    } else {
        goto L54;
    }
L53:
/* Computing MAX */
    r__3 = (r__1 = *rint1 - rint3, abs(r__1)) / (abs(rint3) + 1.f) *
            (real) (*l1),
    r__4 = (r__2 = *rint2 - rint4, abs(r__2)) / (abs(rint4) + 1.f) *
            (real) (*l2);
    bc = max(r__3,r__4);
    if (bc - e2 <= 0.f) {
        goto L56;
    } else {
        goto L54;
    }
L54:
    rint3 = *rint1;
    rint4 = *rint2;
    eps /= 32.f;
    if (*xa + sys059 <= 0.f) {
        goto L55;
    } else {
        goto L59;
    }
L55:
    if (eps - cone <= 0.f) {
        goto L56;
    } else {
        goto L57;
    }
L56:
    e3 = bc;
    goto L59;
L57:
    *a = l;
    goto L39;
L58:
    z__ = TRUE_;
    goto L43;
L59:
    if (*b < *alfa && x == 1 || *b > *beta && x == -1) {
        goto L48;
    }
    *e = e2;
    *a = l;
    *b = j;
    c__ += *rint1;
    g += *rint2;
    d__ = c__;
    i__ = g;
    if (y) {
        goto L62;
    }
    if (x + 1 <= 0) {
        goto L60;
    } else {
        goto L61;
    }
L60:
    t = e3;
    m = *b;
    *b = k;
    x = 1;
    goto L38;
L61:
    e3 += t;
    *a = m;
    *e *= 2.f;
L62:
    *e1 = e3;
    *rint1 = d__;
    *rint2 = i__;
    if (! nis) {
        goto L63;
    }
    *rint1 = -(*rint1);
    *rint2 = -(*rint2);
L63:
    return 0;
} /* qsfar_c */
